%global srcname MockSSH
%global modname mockssh
%global srcurl  https://github.com/ncouture

Name:           python-%{modname}
Version:        1.4.5
Release:        1%{?dist}
Summary:        Mock an SSH server and all commands it supports

License:        BSD
URL:            %{srcurl}/%{srcname}
Source0:        %{url}/archive/v%{version}.tar.gz#/%{srcname}-%{version}.tar.gz
# python3 support, https://github.com/ncouture/MockSSH/pull/25
Patch0:         %{srcname}-1.4.5-python3-print.patch
BuildArch:      noarch
 
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

BuildRequires:  python%{python3_pkgversion}-twisted
BuildRequires:  python%{python3_pkgversion}-cryptography
BuildRequires:  python%{python3_pkgversion}-bcrypt
BuildRequires:  python%{python3_pkgversion}-pyasn1
BuildRequires:  python%{python3_pkgversion}-paramiko

%global _description\
MockSSH was developed to emulate operating systems behind SSH servers in order\
to test task automation without having access to the real servers.There has\
been interest in using MockSSH to perform endtoend unit tests against SSH\
servers and as such, a threaded version of MockSSH server is available as of\
version 1.4 (thanks to Claudio Mignanti).MockSSH is derived from kippo, an SSH\
honeypot.

%description %{_description}

%package -n     python%{python3_pkgversion}-%{modname}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{modname}}

# FIXME twisted is not available in epel7 
Requires:       python%{python3_pkgversion}-twisted
# FIXME paramiko needed as runtime dependency?
Requires:       python%{python3_pkgversion}-paramiko
# FIXME hylang is not packaged yet
Requires:       python%{python3_pkgversion}-hy

%description -n python%{python3_pkgversion}-%{modname} %{_description}


%prep
%autosetup -p1 -n %{srcname}-%{version}
# Remove bundled egg-info
rm -rf *.egg-info

%build
%py3_build

%install
%py3_install
cp %{buildroot}/%{_bindir}/mock_cisco.py %{buildroot}/%{_bindir}/mock_cisco.py-%{python3_version}
ln -s %{_bindir}/mock_cisco.py-%{python3_version} %{buildroot}/%{_bindir}/mock_cisco.py-3
cp %{buildroot}/%{_bindir}/mock.hy %{buildroot}/%{_bindir}/mock.hy-%{python3_version}
ln -s %{_bindir}/mock.hy-%{python3_version} %{buildroot}/%{_bindir}/mock.hy-3
cp %{buildroot}/%{_bindir}/mock_F5.py %{buildroot}/%{_bindir}/mock_F5.py-%{python3_version}
ln -s %{_bindir}/mock_F5.py-%{python3_version} %{buildroot}/%{_bindir}/mock_F5.py-3
#find %{buildroot}/%{_bindir} -type f -exec mv -v '{}' %{buildroot}/%{_bindir}/%{modname}-$(basename '{}') \;

%check
# see Makefile
touch tests/__init__.py
# FIXME TypeError, https://github.com/ncouture/MockSSH/issues/24
%{__python3} -m unittest discover -s tests/


%files -n python%{python3_pkgversion}-%{modname}
%license COPYRIGHT
%doc README.md examples/
%{_bindir}/mock_cisco.py
%{_bindir}/mock_cisco.py-3
%{_bindir}/mock_cisco.py-%{python3_version}
%{_bindir}/mock.hy
%{_bindir}/mock.hy-3
%{_bindir}/mock.hy-%{python3_version}
%{_bindir}/mock_F5.py
%{_bindir}/mock_F5.py-3
%{_bindir}/mock_F5.py-%{python3_version}
%{python3_sitelib}/__pycache__/*
%{python3_sitelib}/%{srcname}.py
%{python3_sitelib}/%{modname}y
%{python3_sitelib}/%{srcname}-%{version}-py?.?.egg-info

%changelog
* Wed Sep 09 2020 Raphael Groner <raphgro@fedoraproject.org> - 1.4.5-1
- initial
